VST 3 SDK: Steinberg Namespace Reference
Author: Steinberg

VST 3 SDK VST 3.8 SDK for developing VST plug-in

Loading...
Searching...
No Matches
Namespaces | Classes | Typedefs | Enumerations | Functions | Variables
Steinberg Namespace Reference

A replacement for InitModule and DeinitModule. More...

## Namespaces
namespace | FUnknownImpl
namespace | FUnknownPrivate
namespace | GeoConstants
namespace | KeyCodes
namespace | Linux
namespace | ModuleInfoLib
namespace | OneReaderOneWriter
namespace | PluginFactoryDetail
namespace | StringConvert
namespace | SystemClipboard
namespace | U
namespace | Vst

## Classes
class | ConstStringTable
class | CPluginFactory
| Default Class Factory implementation. More...
class | CPluginView
| Plug-In view default implementation. More...
struct | FReleaser
class | FUID
class | FUnknown
class | FUnknownPtr
class | FVariant
class | IAttributes
class | IAttributes2
class | IBStream
class | ICloneable
class | IDependent
class | IErrorContext
class | IPersistent
class | IPlugFrame
class | IPluginBase
class | IPluginCompatibility
class | IPluginFactory
class | IPluginFactory2
class | IPluginFactory3
class | IPluginFactoryInternal
class | IPlugView
class | IPlugViewContentScaleSupport
class | IPtr
class | ISizeableStream
class | IString
class | IStringResult
class | ITest
class | ITestFactory
class | ITestResult
class | ITestSuite
class | IUpdateHandler
class | IWaylandFrame
class | IWaylandHost
struct | KeyCode
class | MemoryStream
| Memory based Stream for IBStream implementation (using malloc). More...
struct | ModuleInfo
struct | ModuleInitializer
struct | ModuleTerminator
struct | ObjCClassBuilder
struct | ObjCInstance
struct | ObjCVariable
class | OPtr
struct | PClassInfo
struct | PClassInfo2
struct | PClassInfoW
struct | PFactoryInfo
class | PluginFactory
| IPluginFactory implementation with compile time provided factory and class infos. More...
class | ResizableMemoryIBStream
class | UString
class | UStringBuffer
struct | ViewRect

## Typedefs
typedef char | int8
typedef uint8_t | uint8
typedef unsigned char | uchar
typedef int16_t | int16
typedef uint16_t | uint16
typedef int32_t | int32
typedef uint32_t | uint32
typedef int64_t | int64
typedef uint64_t | uint64
typedef int64 | TSize
typedef int32 | tresult
typedef uint64 | TPtrInt
typedef uint8 | TBool
typedef char | char8
typedef char16_t | char16
typedef char16 | char
typedef const char8 * | CStringA
typedef const char16 * | CStringW
typedef const char * | CString
typedef const char8 * | FIDString
typedef int32 | UCoord
typedef int64 | LARGE_INT
typedef char | TUID[16]
typedef FIDString | IAttrID
typedef uint32 | ColorSpec
typedef uint8 | ColorComponent
typedef ColorSpec | UColorSpec
typedef ColorComponent | UColorComponent
typedef UStringBuffer< 128 > | UString128
typedef UStringBuffer< 256 > | UString256
using | PlatformModuleHandle = void*
using | ModuleInitFunction = std::function<void ()>
using | ModuleInitPriority = uint32

## Enumerations
enum | Direction
enum | Orientation
enum | VirtualKeyCodes
enum | KeyModifier
enum | StandardColor

## Functions
int32 | _tstrlen (const T *wcs)
int32 | tstrlen (const char *str)
int32 | strlen8 (const char8 *str)
int32 | strlen16 (const char16 *str)
int32 | _tstrcmp (const T *src, const T *dst)
int32 | tstrcmp (const char *src, const char *dst)
int32 | strcmp8 (const char8 *src, const char8 *dst)
int32 | strcmp16 (const char16 *src, const char16 *dst)
int32 | strcmpT (const T *first, const T *last)
int32 | strcmpT< char8 > (const char8 *first, const char8 *last)
int32 | strcmpT< char16 > (const char16 *first, const char16 *last)
int32 | _tstrncmp (const T *first, const T *last, uint32 count)
int32 | tstrncmp (const char *first, const char *last, uint32 count)
int32 | strncmp8 (const char8 *first, const char8 *last, uint32 count)
int32 | strncmp16 (const char16 *first, const char16 *last, uint32 count)
int32 | strncmpT (const T *first, const T *last, uint32 count)
int32 | strncmpT< char8 > (const char8 *first, const char8 *last, uint32 count)
int32 | strncmpT< char16 > (const char16 *first, const char16 *last, uint32 count)
T * | _tstrcpy (T *dst, const T *src)
char * | tstrcpy (char *dst, const char *src)
char8 * | strcpy8 (char8 *dst, const char8 *src)
char16 * | strcpy16 (char16 *dst, const char16 *src)
T * | _tstrncpy (T *dest, const T *source, uint32 count)
char * | tstrncpy (char *dest, const char *source, uint32 count)
char8 * | strncpy8 (char8 *dest, const char8 *source, uint32 count)
char16 * | strncpy16 (char16 *dest, const char16 *source, uint32 count)
T * | _tstrcat (T *dst, const T *src)
char * | tstrcat (char *dst, const char *src)
char8 * | strcat8 (char8 *dst, const char8 *src)
char16 * | strcat16 (char16 *dst, const char16 *src)
void | str8ToStr16 (char16 *dst, const char8 *src, int32 n=-1)
bool | FIDStringsEqual (FIDString id1, FIDString id2)
bool | strEmpty (const char *str)
bool | str8Empty (const char8 *str)
bool | str16Empty (const char16 *str)
const TUID & | getTUID ()
const T & | Min (const T &a, const T &b)
const T & | Max (const T &a, const T &b)
T | Abs (const T &value)
T | Sign (const T &value)
T | Bound (T minval, T maxval, T x)
void | Swap (T &t1, T &t2)
bool | IsApproximateEqual (T t1, T t2, T epsilon)
T | ToNormalized (const T value, const int32 numSteps)
int32 | FromNormalized (const T &norm, const int32 numSteps)
bool | operator== (const FVariant &v1, const FVariant &v2)
bool | operator!= (const FVariant &v1, const FVariant &v2)
SMTG_CONSTEXPR14 char | VirtualKeyCodeToChar (uint8 vKey)
SMTG_CONSTEXPR14 uint8 | CharToVirtualKeyCode (char character)
IPtr< I > | owned (I *p)
IPtr< I > | shared (I *p)
SMTG_CONSTEXPR ColorSpec | MakeColorSpec (ColorComponent r, ColorComponent g, ColorComponent b)
SMTG_CONSTEXPR ColorSpec | MakeColorSpec (ColorComponent r, ColorComponent g, ColorComponent b, ColorComponent a)
SMTG_CONSTEXPR ColorComponent | GetBlue (ColorSpec cs)
SMTG_CONSTEXPR ColorComponent | GetGreen (ColorSpec cs)
SMTG_CONSTEXPR ColorComponent | GetRed (ColorSpec cs)
SMTG_CONSTEXPR ColorComponent | GetAlpha (ColorSpec cs)
void | SetBlue (ColorSpec &argb, ColorComponent b)
void | SetGreen (ColorSpec &argb, ColorComponent g)
void | SetRed (ColorSpec &argb, ColorComponent r)
void | SetAlpha (ColorSpec &argb, ColorComponent a)
double | NormalizeColorComponent (ColorComponent c)
ColorComponent | DenormalizeColorComponent (double c)
void | SetAlphaNorm (ColorSpec &argb, double a)
double | GetAlphaNorm (ColorSpec cs)
double | NormalizeAlpha (uint8 alpha)
ColorComponent | DenormalizeAlpha (double alphaNorm)
ColorSpec | StripAlpha (ColorSpec argb)
ColorSpec SMTG_CONSTEXPR | BlendColor (ColorSpec color, double opacity)
void | StringCopy (TDstChar *dst, int32 dstSize, const TSrcChar *src, int32 srcSize=-1)
int32 | StringLength (const TSrcChar *src, int32 srcSize=-1)
bool | strEmpty (const char *str)
bool | str8Empty (const char8 *str)
bool | str16Empty (const char16 *str)
| DEF_CLASS_IID (ITest) DEF_CLASS_IID(ITestSuite) DEF_CLASS_IID(ITestFactory) namespace Vst
bool | openURLInDefaultApplication (const String &address)
| Open the given URL into the default web browser.
std::string | readFile (const std::string &path)
| Reads entire file content.
PlatformModuleHandle | getPlatformModuleHandle ()

## Variables
| kNoInterface
| kResultOk
| kResultTrue
| kResultFalse
| kInvalidArgument
| kNotImplemented
| kInternalError
| kNotInitialized
| kOutOfMemory
| kNorth
| kNorthEast
| kEast
| kSouthEast
| kSouth
| kSouthWest
| kWest
| kNorthWest
| kNoDirection
| kNumberOfDirections
| kHorizontal
| kVertical
| kNumberOfOrientations
| KEY_BACK
| KEY_TAB
| KEY_CLEAR
| KEY_RETURN
| KEY_PAUSE
| KEY_ESCAPE
| KEY_SPACE
| KEY_NEXT
| KEY_END
| KEY_HOME
| KEY_LEFT
| KEY_UP
| KEY_RIGHT
| KEY_DOWN
| KEY_PAGEUP
| KEY_PAGEDOWN
| KEY_SELECT
| KEY_PRINT
| KEY_ENTER
| KEY_SNAPSHOT
| KEY_INSERT
| KEY_DELETE
| KEY_HELP
| KEY_NUMPAD0
| KEY_NUMPAD1
| KEY_NUMPAD2
| KEY_NUMPAD3
| KEY_NUMPAD4
| KEY_NUMPAD5
| KEY_NUMPAD6
| KEY_NUMPAD7
| KEY_NUMPAD8
| KEY_NUMPAD9
| KEY_MULTIPLY
| KEY_ADD
| KEY_SEPARATOR
| KEY_SUBTRACT
| KEY_DECIMAL
| KEY_DIVIDE
| KEY_F1
| KEY_F2
| KEY_F3
| KEY_F4
| KEY_F5
| KEY_F6
| KEY_F7
| KEY_F8
| KEY_F9
| KEY_F10
| KEY_F11
| KEY_F12
| KEY_NUMLOCK
| KEY_SCROLL
| KEY_SHIFT
| KEY_CONTROL
| KEY_ALT
| KEY_EQUALS
| KEY_CONTEXTMENU
| KEY_MEDIA_PLAY
| KEY_MEDIA_STOP
| KEY_MEDIA_PREV
| KEY_MEDIA_NEXT
| KEY_VOLUME_UP
| KEY_VOLUME_DOWN
| KEY_F13
| KEY_F14
| KEY_F15
| KEY_F16
| KEY_F17
| KEY_F18
| KEY_F19
| KEY_F20
| KEY_F21
| KEY_F22
| KEY_F23
| KEY_F24
| KEY_SUPER
| VKEY_FIRST_CODE
| VKEY_LAST_CODE
| VKEY_FIRST_ASCII
| kShiftKey
| kAlternateKey
| kCommandKey
| kControlKey
| kBlack
| kWhite
| kGray5
| kGray10
| kGray20
| kGray30
| kGray40
| kGray50
| kGray60
| kGray70
| kGray80
| kGray90
| kRed
| kLtRed
| kDkRed
| kGreen
| kLtGreen
| kDkGreen
| kBlue
| kLtBlue
| kDkBlue
| kMagenta
| kLtMagenta
| kDkMagenta
| kYellow
| kLtYellow
| kDkYellow
| kOrange
| kLtOrange
| kDkOrange
| kGold
| kBlack50
| kBlack70
| kNumStandardColors
| kLtGray
| kGray
| kDkGray
const FIDString | kPlatformStringWin
const FIDString | kPlatformStringMac
const FIDString | kPlatformStringIOS
const FIDString | kPlatformStringLinux
const FIDString | kPlatformString
const FIDString | kPlatformTypeHWND
const FIDString | kPlatformTypeHIView
const FIDString | kPlatformTypeNSView
const FIDString | kPlatformTypeUIView
const FIDString | kPlatformTypeX11EmbedWindowID
const FIDString | kPlatformTypeWaylandSurfaceID
const FIDString | kPlatformStringWin
const FIDString | kPlatformStringMac
const FIDString | kPlatformStringIOS
const FIDString | kPlatformStringLinux
const FIDString | kPlatformString
const FIDString | kPlatformTypeHWND
const FIDString | kPlatformTypeHIView
const FIDString | kPlatformTypeNSView
const FIDString | kPlatformTypeUIView
const FIDString | kPlatformTypeX11EmbedWindowID
const FIDString | kPlatformTypeWaylandSurfaceID
const FIDString | kPlatformTypeHWND
const FIDString | kPlatformTypeHIView
const FIDString | kPlatformTypeNSView
const FIDString | kPlatformTypeUIView
const FIDString | kPlatformTypeX11EmbedWindowID
const FIDString | kPlatformTypeWaylandSurfaceID
CPluginFactory * | gPluginFactory

## Detailed Description

A replacement for InitModule and DeinitModule.

If you link this file the InitModule and DeinitModule functions are implemented and you can use this to register functions that will be called when the module is loaded and before the module is unloaded.

Use this for one time initializers or cleanup functions. For example: if you depend on a 3rd party library that needs initialization before you can use it you can write an initializer like this:

static ModuleInitializer InitMyExternalLib ([] () { MyExternalLib::init (); });

Or you have a lazy create wavetable you need to free the allocated memory later:

static ModuleTerminator FreeWaveTableMemory ([] () { MyWaveTable::free (); });

## Typedef Documentation

## ◆ PlatformModuleHandle

using PlatformModuleHandle = void*

## ◆ ModuleInitFunction

using ModuleInitFunction = std::function<void ()>

## ◆ ModuleInitPriority

using ModuleInitPriority = uint32

## Function Documentation

## ◆ DEF_CLASS_IID()

DEF_CLASS_IID | ( | ITest |  | ) |

## ◆ getPlatformModuleHandle()

PlatformModuleHandle getPlatformModuleHandle | ( |  | ) |

## Variable Documentation

## ◆ gPluginFactory

CPluginFactory* gPluginFactory
| extern

Empty

Copyright © Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.